﻿using System;
using System.Collections.Generic;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

namespace HeuristicLab.Modeling.SQLiteBackend {
  [Table(Name = "Algorithm")]
  public class Algorithm {
    public Algorithm() {
      models = new EntitySet<Model>(attach_Model, detach_Model);
    }

    private int id;
    [Column(Storage = "id", DbType = "integer", IsPrimaryKey = true, IsDbGenerated = true, UpdateCheck = UpdateCheck.Never)]
    public int Id {
      get { return this.id; }
      private set { this.id = value; }
    }

    private string name;
    [Column(Storage = "name", DbType = "VarChar(50) NOT NULL", CanBeNull = false)]
    public string Name {
      get { return this.name; }
      private set { this.name = value; }
    }

    private string description;
    [Column(Storage = "description", DbType = "VarChar(200) NOT NULL", CanBeNull = true)]
    public string Description {
      get { return this.description; }
      private set { this.description = value; }
    }

    private EntitySet<Model> models;
    [Association(Storage = "models", ThisKey = "Id", OtherKey = "AlgorithmId")]
    public EntitySet<Model> Models {
      get {
        if (models.HasLoadedOrAssignedValues)
          return models;
        return null;
      }
      set {
        models.Assign(value);
      }
    }

    private void attach_Model(Model model) {
      model.Algorithm = this;
    }

    private void detach_Model(Model model) {
      model.Algorithm = null;
    }
  }
}
