﻿using System;
using System.Collections.Generic;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

namespace HeuristicLab.Modeling.SQLiteBackend {
  [Table(Name = "InputVariable")]
  public class InputVariable {
    public InputVariable() {
      this.model = default(EntityRef<Model>);
      this.variable = default(EntityRef<Variable>);
    }

    public InputVariable(Model model, Variable variable) :base() {
      this.modelId = model.Id;
      this.model.Entity = model;
      this.variableId = variable.Id;
      this.variable.Entity = variable;
    }

    private int variableId;
    [Column(Storage = "variableId", DbType = "Int not null", IsPrimaryKey = true)]
    public int TargetVariableId {
      get { return this.variableId; }
      private set {
        if (variableId != value) {
          variableId = value;
        }
      }
    }

    private EntityRef<Variable> variable;
    [Association(Storage="variable", ThisKey="variableId", OtherKey="Id", IsForeignKey=true)]
    public Variable Variable {
      get { return variable.Entity; }
    }

    private int modelId;
    [Column(Storage = "modelId", DbType = "Int not null", IsPrimaryKey = true)]
    public int ModelId {
      get { return this.modelId; }
      private set {
        if (modelId != value) {
          modelId = value;
        }
      }
    }

    private EntityRef<Model> model;
    [Association(Storage = "model", ThisKey = "modelId", OtherKey = "Id", IsForeignKey = true)]
    public Model Model {
      get { return model.Entity; }
    }
  }
}
