﻿using System;
using System.Collections.Generic;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

namespace HeuristicLab.Modeling.SQLiteBackend {
  public class ModelingDataContext : DataContext{

    public static string connectionString = @"data source=D:\Reps\HL3-Source\branches\HeuristicLab.Modeling Database Backend\sources\HeuristicLab.Modeling.SQLiteBackend\3.2\HeuristicLab.Modeling.SQLiteBackend.database";

    public ModelingDataContext() : this(connectionString) {
    }

    public ModelingDataContext(string connection)
      : base(connection) {
    }

    #region Tables
    public Table<Algorithm> Algorithms {
      get { return GetTable<Algorithm>(); }
    }

    public Table<InputVariable> InputVariables {
      get { return GetTable<InputVariable>(); }
    }

    public Table<InputVariableResult> InputVariableResults {
      get { return GetTable<InputVariableResult>(); }
    }
    public Table<Model> Models {
      get { return GetTable<Model>(); }
    }

    public Table<ModelResult> ModelResults {
      get { return GetTable<ModelResult>(); }
    }

    public Table<Problem> Problems {
      get { return GetTable<Problem>(); }
    }

    public Table<Result> Results {
      get { return GetTable<Result>(); }
    }
    #endregion
  }
}
